All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
cl::Image1D Class Reference

Class interface for 1D Image Memory objects. More...

`#include <cl2.hpp>`

Inherits cl::Image.

## Public Member Functions

| Image1D (const Context &context, cl_mem_flags flags, ImageFormat format, size_type width, void *host_ptr=NULL, cl_int *err=NULL)
| Constructs a 1D Image in a specified context. More...
| Image1D ()
| Default constructor - initializes to NULL. More...
| Image1D (const cl_mem &image1D, bool retainObject=false)
| Constructor from cl_mem - takes ownership. More...
Image1D & | operator= (const cl_mem &rhs)
| Assignment from cl_mem - performs shallow copy. More...
| Image1D (const Image1D &img)
| Copy constructor to forward copy to the superclass correctly. Required for MSVC. More...
Image1D & | operator= (const Image1D &img)
| Copy assignment to forward copy to the superclass correctly. Required for MSVC. More...
| Image1D (Image1D &&img) CL_HPP_NOEXCEPT_
| Move constructor to forward move to the superclass correctly. Required for MSVC. More...
Image1D & | operator= (Image1D &&img)
| Move assignment to forward move to the superclass correctly. Required for MSVC. More...
Public Member Functions inherited from cl::Image
template<typename T >
cl_int | getImageInfo (cl_image_info name, T *param) const
| Wrapper for clGetImageInfo(). More...
template<cl_int name>
detail::param_traits < detail::cl_image_info, name > ::param_type | getImageInfo (cl_int *err=NULL) const
| Wrapper for clGetImageInfo() that returns by value. More...
Public Member Functions inherited from cl::Memory
| Memory ()
| Default constructor - initializes to NULL. More...
| Memory (const cl_mem &memory, bool retainObject)
| Constructor from cl_mem - takes ownership. More...
Memory & | operator= (const cl_mem &rhs)
| Assignment operator from cl_mem - takes ownership. More...
| Memory (const Memory &mem)
| Copy constructor to forward copy to the superclass correctly. Required for MSVC. More...
Memory & | operator= (const Memory &mem)
| Copy assignment to forward copy to the superclass correctly. Required for MSVC. More...
| Memory (Memory &&mem) CL_HPP_NOEXCEPT_
| Move constructor to forward move to the superclass correctly. Required for MSVC. More...
Memory & | operator= (Memory &&mem)
| Move assignment to forward move to the superclass correctly. Required for MSVC. More...
template<typename T >
cl_int | getInfo (cl_mem_info name, T *param) const
| Wrapper for clGetMemObjectInfo(). More...
template<cl_int name>
detail::param_traits < detail::cl_mem_info, name > ::param_type | getInfo (cl_int *err=NULL) const
| Wrapper for clGetMemObjectInfo() that returns by value. More...
cl_int | setDestructorCallback (void(CL_CALLBACK *pfn_notify)(cl_mem, void *), void *user_data=NULL)
| Registers a callback function to be called when the memory object is no longer needed. More...
Public Member Functions inherited from cl::detail::Wrapper< cl_mem >
| Wrapper ()
| Wrapper (const cl_type &obj, bool retainObject)
| Wrapper (const Wrapper< cl_type > &rhs)
| Wrapper (Wrapper< cl_type > &&rhs) CL_HPP_NOEXCEPT_
| ~Wrapper ()
Wrapper< cl_type > & | operator= (const Wrapper< cl_type > &rhs)
Wrapper< cl_type > & | operator= (Wrapper< cl_type > &&rhs)
Wrapper< cl_type > & | operator= (const cl_type &rhs)
const cl_type & | operator() () const
cl_type & | operator() ()
const cl_type | get () const
cl_type | get ()

## Additional Inherited Members

Public Types inherited from cl::detail::Wrapper< cl_mem >
typedef cl_mem | cl_type
Protected Member Functions inherited from cl::Image
| Image ()
| Default constructor - initializes to NULL. More...
| Image (const cl_mem &image, bool retainObject=false)
| Constructor from cl_mem - takes ownership. More...
Image & | operator= (const cl_mem &rhs)
| Assignment from cl_mem - performs shallow copy. More...
| Image (const Image &img)
| Copy constructor to forward copy to the superclass correctly. Required for MSVC. More...
Image & | operator= (const Image &img)
| Copy assignment to forward copy to the superclass correctly. Required for MSVC. More...
| Image (Image &&img) CL_HPP_NOEXCEPT_
| Move constructor to forward move to the superclass correctly. Required for MSVC. More...
Image & | operator= (Image &&img)
| Move assignment to forward move to the superclass correctly. Required for MSVC. More...
Protected Member Functions inherited from cl::detail::Wrapper< cl_mem >
cl_int | retain () const
cl_int | release () const
Protected Attributes inherited from cl::detail::Wrapper< cl_mem >
cl_type | object_

## Detailed Description

Class interface for 1D Image Memory objects.

See Memory for details about copy semantics, etc.

See Also
  Memory

## Constructor & Destructor Documentation

cl::Image1D::Image1D | ( | const Context & | context,
|  | cl_mem_flags | flags,
|  | ImageFormat | format,
|  | size_type | width,
|  | void * | host_ptr = `NULL`,
|  | cl_int * | err = `NULL`
| ) |  |

inline

Constructs a 1D Image in a specified context.

Wraps clCreateImage().

cl::Image1D::Image1D | ( |  | ) |

inline

Default constructor - initializes to NULL.

cl::Image1D::Image1D | ( | const cl_mem & | image1D,
|  | bool | retainObject = `false`
| ) |  |

inlineexplicit

Constructor from cl_mem - takes ownership.

Parameters

  retainObject | will cause the constructor to retain its cl object. Defaults to false to maintain compatibility with earlier versions. See Memory for further details.

cl::Image1D::Image1D | ( | const Image1D & | img | ) |

inline

Copy constructor to forward copy to the superclass correctly. Required for MSVC.

cl::Image1D::Image1D | ( | Image1D && | img | ) |

inline

Move constructor to forward move to the superclass correctly. Required for MSVC.

## Member Function Documentation

Image1D& cl::Image1D::operator= | ( | const cl_mem & | rhs | ) |

inline

Assignment from cl_mem - performs shallow copy.

See Memory for further details.

Image1D& cl::Image1D::operator= | ( | const Image1D & | img | ) |

inline

Copy assignment to forward copy to the superclass correctly. Required for MSVC.

Image1D& cl::Image1D::operator= | ( | Image1D && | img | ) |

inline

Move assignment to forward move to the superclass correctly. Required for MSVC.

The documentation for this class was generated from the following file:

- /home/travis/build/CMU-Perceptual-Computing-Lab/openpose/include/openpose/gpu/cl2.hpp